<?php
/*
Plugin Name: Open Lazy
Version: 1.1
Plugin URI: http://www.xiaomac.com/
Description: Lazy than you can imagine.
Author: Afly
Author URI: http://www.xiaomac.com/
License: GPL v2 - http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
Text Domain: open-link
Domain Path: /lang
*/

$GLOBALS['olop'] = get_option('olop');
function olop($k,$v=NULL){
	if(isset($GLOBALS['olop']) && isset($GLOBALS['olop'][$k])) return isset($v) ? $GLOBALS['olop'][$k]==$v : $GLOBALS['olop'][$k];
	return '';
}

add_action('init', 'open_lazy_init', 1);
function open_lazy_init() {
	if(olop('open_lazy_scs_akey') && olop('open_lazy_scs_skey')){
		require_once('lib/SCS.php');
		require_once('lib/SCSWrapper.php');
		SCS::setAuth(olop('open_lazy_scs_akey'), olop('open_lazy_scs_skey'));
	}
	if (!is_admin()) {
		if(olop('open_lazy_unload_wp_head')){
			$remove = explode(',',olop('open_lazy_unload_wp_head'));
			foreach($remove as $k){
				$tk = trim($k);
				if($tk=='feed_links') remove_action('wp_head',$tk,2);
				else if($tk=='feed_links_extra') remove_action('wp_head',$tk,3);
				else if($tk=='print_emoji_detection_script') remove_action('wp_head',$tk,7);
				else remove_action('wp_head',$tk);
			}
		}
		if(olop('open_lazy_ui_emoji',1)) remove_action( 'wp_print_styles', 'print_emoji_styles' );
	}else{
		if(olop('open_lazy_ui_emoji',1)){
			remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );
			remove_action( 'admin_print_styles', 'print_emoji_styles' );
		}
		add_filter('pre_update_option_olop', 'open_lazy_admin_options_page_save', 10, 2);
	}
}

add_action('admin_init', 'open_lazy_admin_init', 1);
function open_lazy_admin_init() {
	load_plugin_textdomain( 'open-lazy', '', dirname( plugin_basename( __FILE__ ) ) . '/lang' );
	register_setting( 'open_lazy_admin_options_group', 'olop' );
}

add_filter("plugin_action_links_".plugin_basename( __FILE__ ), 'open_lazy_admin_settings_link' );
function open_lazy_admin_settings_link($links) {
	array_unshift($links, '<a href="options-general.php?page=open-lazy">'.__('Settings').'</a>');
	return $links;
}

add_action('admin_menu', 'open_lazy_admin_add_page');
function open_lazy_admin_add_page() {
	add_options_page(__('Open Lazy','open-lazy'), __('Open Lazy','open-lazy'), 'manage_options', 'open-lazy', 'open_lazy_admin_options_page');
}

add_action( 'wp_enqueue_scripts', 'open_lazy_script_style_action', 100 );
add_action( 'login_enqueue_scripts', 'open_lazy_script_style_action', 100 );
add_action( 'admin_enqueue_scripts', 'open_lazy_script_style_action', 100 );
function open_lazy_script_style_action() {
	if(olop('open_lazy_ui_font_awesome',1)) wp_enqueue_style('open-lazy-font-awesome', plugins_url( 'ui/font-awesome.min.css', __FILE__ ) );
	if(olop('open_lazy_pack',1) && olop('open_lazy_pack_style_disable')){
		$disable = explode(',',olop('open_lazy_pack_style_disable'));
		foreach ($disable as $key) { wp_deregister_style(trim($key)); }
	}
}

if(olop('open_lazy_ui_open_sans',1)){
	add_filter( 'gettext_with_context', 'open_lazy_ui_open_sans_action', 888, 4 );
	function open_lazy_ui_open_sans_action( $translations, $text, $context, $domain ) {
		if( 'Open Sans font: on or off' == $context && 'on' == $text ) $translations = 'off';
		return $translations;
	}
}

if(olop('open_lazy_pack',1)){
	if(isset($_GET['action'])){
		if($_GET['action']==md5(md5('cache').'open-lazy')) add_action( 'wp_enqueue_scripts', 'open_lazy_pack_action_cache', 10000 );
		if($_GET['action']==md5(md5('clear').'open-lazy')) add_action( 'wp_enqueue_scripts', 'open_lazy_pack_action_clear', 10000 );
	}else{
		add_action( 'wp_enqueue_scripts', 'open_lazy_pack_action', 10000 );
		add_action( 'login_enqueue_scripts', 'open_lazy_pack_action', 10000 );
	}
}

function open_lazy_pack_action() {
	$uploads = wp_upload_dir();
	$pack = olop('pack');
	if(olop('open_lazy_pack_style_path') && is_array($pack) && count($pack['style']['packed'])>0){
		global $wp_styles;
		foreach($pack['style']['packed'] as $kv){ $wp_styles->done[] = $kv['name']; }
		wp_enqueue_style('open-lazy-style', $uploads['baseurl'].olop('open_lazy_pack_style_path'));
	}
	if(olop('open_lazy_pack_script_path') && is_array($pack) && count($pack['script']['packed'])>0){
		global $wp_scripts;
		foreach($pack['script']['packed'] as $kv){ $wp_scripts->done[] = $kv['name']; }
		wp_enqueue_script('open-lazy-script',$uploads['baseurl'].olop('open_lazy_pack_script_path'),array(),false,(olop('open_lazy_pack_script_footer',1)));
	}
}

function open_lazy_pack_action_cache(){
	if(!is_super_admin()) return;
	$uploads = wp_upload_dir();
	$txt = $err = '';
	$arr_style_unpack = $arr_style_packed = $arr_script_unpack = $arr_script_packed = array();
	if(olop('open_lazy_pack_style_path')){
		global $wp_styles;
		$filter = olop('open_lazy_pack_style_filter');
		$queue = $wp_styles->queue;
		$wp_styles->all_deps($queue);
		foreach( $wp_styles->to_do as $key => $handle ) {
			if ( !in_array($handle, $wp_styles->done, true) && isset($wp_styles->registered[$handle]) ) {
				if(!$wp_styles->registered[$handle]->src) continue;
				$src = html_entity_decode( $wp_styles->registered[$handle]->src );
				if(isset($wp_styles->registered[$handle]->extra['conditional'])||($filter&&open_lazy_pack_check_exclude($filter, $handle, $src))){
					$arr_style_unpack[] = array( 'name'=> $handle, 'url' => $src );
					continue;
				}
				if ( false===stripos( $src, '://' ) ) $src = home_url() . $src;
				$txt .= "/* $handle: ($src) */\n";
				$_remote_get = wp_remote_get(add_query_arg('v', rand(1, 9999999), $src));
				if (! is_wp_error($_remote_get) && $_remote_get['response']['code'] == 200) {
					$arr_style_packed[] = array( 'name'=> $handle, 'url' => $src );
					$content = open_lazy_pack_style_zipper($_remote_get['body'], $src);
					$txt .= $content."\n\n";
				}
				else {
					$err .= "/*\nError: $src\n";
					$err .= "HTTP Code: {$_remote_get['response']['code']} ({$_remote_get['response']['message']})\n*/\n\n";
				}
			}
		}
		if(count($arr_style_unpack)+count($arr_style_packed)){
			$GLOBALS['olop']['pack']['style'] = array('packed'=>$arr_style_packed,'unpack'=>$arr_style_unpack);
			update_option('olop',$GLOBALS['olop']);
		}
		$txt = "/* Cache: ".time()." */\n" . $txt;
		$filepath = $uploads['basedir'].olop('open_lazy_pack_style_path');
		if(olop('open_lazy_scs',1)){
			$uri = parse_url($filepath);
			$ok = SCS::putObject($txt, $uri['host'], trim($uri['path'],'/'), SCS::ACL_PUBLIC_READ, array(), array('Content-Type'=>'text/css'));
		}else{
			$ok = (file_put_contents($filepath, $txt)>0);
		}
		if(!$ok) $err .= "/* Error: ($filepath) */\n";
   }
	if(olop('open_lazy_pack_script_path')){
		global $wp_scripts;
		$filter = olop('open_lazy_pack_script_filter');
		$txt = '';
		$queue = $wp_scripts->queue;
		$wp_scripts->all_deps($queue);
		foreach( $wp_scripts->to_do as $key => $handle ) {
			if ( !in_array($handle, $wp_scripts->done, true) && isset($wp_scripts->registered[$handle]) ) {
				if(!$wp_scripts->registered[$handle]->src) continue;
				$src = html_entity_decode( $wp_scripts->registered[$handle]->src );
				if($filter && open_lazy_pack_check_exclude($filter, $handle, $src)){
					$arr_script_unpack[] = array( 'name'=> $handle, 'url' => $src );
					continue;
				}
				if ( false===stripos( $src, '://' ) ) $src = home_url() . $src;
				$txt .= "/* $handle: ($src) */\n";
				$_remote_get = wp_remote_get(add_query_arg('v', rand(1, 9999999), $src));
				if (! is_wp_error($_remote_get) && $_remote_get['response']['code'] == 200) {
					$arr_script_packed[] = array( 'name'=> $handle, 'url' => $src );
					$txt .= $_remote_get['body'].";\n\n";
				} else {
					$err .= "/*\nError: $src\n";
					$err .= "HTTP Code: {$_remote_get['response']['code']} ({$_remote_get['response']['message']})\n*/\n\n";
				}
			}
		}
		if(count($arr_script_unpack)+count($arr_script_packed)){
			$GLOBALS['olop']['pack']['script'] = array('packed'=>$arr_script_packed,'unpack'=>$arr_script_unpack);
			update_option('olop',$GLOBALS['olop']);
		}
		$txt = "/* Cache: ".time()." */\n" . $txt;
		$filepath = $uploads['basedir'].olop('open_lazy_pack_script_path');
		if(olop('open_lazy_scs',1)){
			$uri = parse_url($filepath);
			$ok = SCS::putObject($txt, $uri['host'], trim($uri['path'],'/'), SCS::ACL_PUBLIC_READ, array(), array('Content-Type'=>'text/javascript'));
		}else{
			$ok = (file_put_contents($filepath, $txt)>0);
		}
		if(!$ok) $err .= "/* Error: ($filepath) */\n";
	}
	echo $err ? $err : '<script>window.opener.location.reload();window.close();</script>';
	exit();
}

function open_lazy_pack_action_clear(){
	if(!is_super_admin()) return;
	$uploads = wp_upload_dir();
	$err = '';
	if(olop('open_lazy_pack_style_path')){
		$path = $uploads['basedir'] . olop('open_lazy_pack_style_path');
		if(!unlink($path)) $err = 'Clear Err: ' . $path . '\n';
		unset($GLOBALS['olop']['pack']['style']);
	}
	if(olop('open_lazy_pack_script_path')){
		$path = $uploads['basedir'] . olop('open_lazy_pack_script_path');
		if(!unlink($path)) $err = 'Clear Err: ' . $path . '\n';
		unset($GLOBALS['olop']['pack']['script']);
	}
	update_option('olop',$GLOBALS['olop']);
	echo $err ? $err : '<script>window.opener.location.reload();window.close();</script>';
	exit();
}

function open_lazy_admin_options_page_save($new_value, $old_value){
	if(isset($old_value['pack']['style'])||isset($old_value['pack']['script'])) $new_value['pack'] = $old_value['pack'];
	return $new_value;
}

function open_lazy_admin_options_page() {
	$plugin_data = get_plugin_data( __FILE__ );
	?>
	<div class="wrap">
		<h2><?php _e('Open Lazy','open-lazy')?>
			<small style="font-size:14px;padding-left:8px;color:#666"><?php echo 'v'.$plugin_data['Version'];?></small>
		</h2>
		<form action="options.php" method="post">
		<?php settings_fields( 'open_lazy_admin_options_group' ); ?>
		<table class="form-table">
		<tr valign="top">
			<th scope="row"><?php _e('SCS','open-lazy')?></th>
		<td><fieldset>
			<label for="olop[open_lazy_scs]"><input name="olop[open_lazy_scs]" id="olop[open_lazy_scs]" type="checkbox" value="1" <?php checked(olop('open_lazy_scs'),1);?> /> <?php _e('Enabled','open-lazy')?></label><br/>
			<label for="olop[open_lazy_scs_akey]"><input name="olop[open_lazy_scs_akey]" id="olop[open_lazy_scs_akey]" size="60" placeholder="Access Key" value="<?php echo olop('open_lazy_scs_akey')?>" /> <?php _e('Access Key','open-lazy')?></label><br/>
			<label for="olop[open_lazy_scs_skey]"><input name="olop[open_lazy_scs_skey]" id="olop[open_lazy_scs_skey]" size="60" placeholder="Secret Key" value="<?php echo olop('open_lazy_scs_skey')?>" /> <?php _e('Secret Key','open-lazy')?></label><br/>
			<label for="olop[open_lazy_scs_path]"><input name="olop[open_lazy_scs_path]" id="olop[open_lazy_scs_path]" size="60" placeholder="scs://{bucket}/{uploads}" value="<?php echo olop('open_lazy_scs_path')?>" /> <?php _e('Base Path','open-lazy')?></label><br/>
			<label for="olop[open_lazy_scs_url]"><input name="olop[open_lazy_scs_url]" id="olop[open_lazy_scs_url]" size="60" placeholder="http://sinacloud.net/{bucket}/{uploads}" value="<?php echo olop('open_lazy_scs_url')?>" /> <?php _e('Base URL','open-lazy')?></label><br/>
		</fieldset>
		<p><?php submit_button('','','open_lazy_scs',false);?><p>
		</td>
		</tr>
		</table>

		<table class="form-table">
		<tr valign="top">
			<th scope="row"><?php _e('Pack','open-lazy')?></th>
		<td><fieldset>
			<label for="olop[open_lazy_pack]"><input name="olop[open_lazy_pack]" id="olop[open_lazy_pack]" type="checkbox" value="1" <?php checked(olop('open_lazy_pack'),1);?> /> <?php _e('Enabled','open-lazy')?></label> &nbsp;
			<label for="olop[open_lazy_pack_script_footer]"><input name="olop[open_lazy_pack_script_footer]" id="olop[open_lazy_pack_script_footer]" type="checkbox" value="1" <?php checked(olop('open_lazy_pack_script_footer'),1);?> /> <?php _e('Load packed script in footer','open-lazy')?></label> <br/>
			<label for="olop[open_lazy_pack_style_path]">
				<input name="olop[open_lazy_pack_style_path]" id="olop[open_lazy_pack_style_path]" size="80" placeholder="/cache/style.css" value="<?php echo olop('open_lazy_pack_style_path')?>" /> <?php _e('Style Path','open-lazy')?></label><br/>
			<label for="olop[open_lazy_pack_script_path]">
				<input name="olop[open_lazy_pack_script_path]" id="olop[open_lazy_pack_script_path]" size="80" placeholder="/cache/script.js" value="<?php echo olop('open_lazy_pack_script_path')?>" /> <?php _e('Script Path','open-lazy')?></label><br/>
			<label for="olop[open_lazy_pack_script_filter]">
				<input name="olop[open_lazy_pack_style_filter]" id="olop[open_lazy_pack_style_filter]" size="40" placeholder="some-style-handle,another-name.css" value="<?php echo olop('open_lazy_pack_style_filter')?>" />
				<input name="olop[open_lazy_pack_script_filter]" id="olop[open_lazy_pack_script_filter]" size="36" placeholder="some-script-handle,another-name.js" value="<?php echo olop('open_lazy_pack_script_filter')?>" /> <?php _e('Style / Script unpack','open-lazy')?></label><br/>
			<label for="olop[open_lazy_pack_style_disable]"><input name="olop[open_lazy_pack_style_disable]" id="olop[open_lazy_pack_style_disable]" size="80" placeholder="open-sans,twentytwelve-fonts" value="<?php echo olop('open_lazy_pack_style_disable')?>" /> <?php _e('Styles disabled','open-lazy')?></label>
			<p><?php submit_button('','','open_lazy_pack',false);?>
			<a href="/?action=<?php echo md5(md5('cache').'open-lazy');?>" class="button" target="_blank">Generate Cache</a>
			<a href="/?action=<?php echo md5(md5('clear').'open-lazy');?>" class="button" target="_blank">Clear Cache</a> </p></br>
			<style>.open_lazy_table .bold{font-weight:bold;}.open_lazy_table td{padding:8px;font-size:12px;text-overflow:ellipsis;overflow:hidden;white-space:nowrap;}</style>
			<?php
			$pack = olop('pack');
			if (is_array($pack) && count($pack,1)>2) {
				if(count($pack['style'],1)>2){
					echo '<table class="widefat fixed open_lazy_table" cellpadding="3" cellspacing="0" style="width:85%">';
					echo '<tr class="bold"><td width=150>#handle</td><td width=120>#name</td><td class="nowrap">#url</td><td width=60></td></tr>';
					foreach($pack['style']['packed'] as $kv) {
						echo '<tr class="alternate"><td>'.$kv['name'].'</td><td>'.basename($kv['url']).'</td><td class="nowrap">'.$kv['url'].'</td><td>Packed</td></tr>';
					}
					foreach($pack['style']['unpack'] as $kv) {
						echo '<tr><td>'.$kv['name'].'</td><td>'.basename($kv['url']).'</td><td class="nowrap">'.$kv['url'].'</td><td>Unpack</td></tr>';
					}
					echo '</table><br/>';
				}
				if (count($pack['script'],1)>2) {
					echo '<table class="widefat fixed open_lazy_table" cellpadding="3" cellspacing="0" style="width:85%">';
					echo '<tr class="bold"><td width=150>#handle</td><td width=120>#name</td><td class="nowrap">#url</td><td width=60></td></tr>';
					foreach($pack['script']['packed'] as $kv) {
						echo '<tr class="alternate"><td>'.$kv['name'].'</td><td>'.basename($kv['url']).'</td><td class="nowrap">'.$kv['url'].'</td><td>Packed</td></tr>';
					}
					foreach($pack['script']['unpack'] as $kv) {
						echo '<tr><td>'.$kv['name'].'</td><td>'.basename($kv['url']).'</td><td class="nowrap">'.$kv['url'].'</td><td>Unpack</td></tr>';
					}
					echo '</table>';
				}
			}?>
		</td>
		</tr>
		</table>
		<table class="form-table">
		<tr valign="top">
			<th scope="row"><?php _e('HTML','open-lazy')?></th>
		<td><fieldset>
			<label for="olop[open_lazy_html]"><input name="olop[open_lazy_html]" id="olop[open_lazy_html]" type="checkbox" value="1" <?php checked(olop('open_lazy_html'),1);?> /> <?php _e('Enabled','open-lazy')?></label> <br/>
			<textarea name="olop[open_lazy_html_wp_head]" id="olop[open_lazy_html_wp_head]" rows="2" cols="80" placeholder="WP Head"><?php echo esc_textarea( olop('open_lazy_html_wp_head') ) ?></textarea><br/>
			<textarea name="olop[open_lazy_html_content_head]" id="olop[open_lazy_html_content_head]" rows="2" cols="80" placeholder="Content Head"><?php echo esc_textarea( olop('open_lazy_html_content_head') ) ?></textarea><br/>
			<textarea name="olop[open_lazy_html_content_footer]" id="olop[open_lazy_html_content_footer]" rows="5" cols="80" placeholder="Content Footer"><?php echo esc_textarea( olop('open_lazy_html_content_footer') ) ?></textarea><br/>
			<textarea name="olop[open_lazy_html_wp_footer]" id="olop[open_lazy_html_wp_footer]" rows="3" cols="80" placeholder="WP Footer"><?php echo esc_textarea( olop('open_lazy_html_wp_footer') ) ?></textarea><br/>
			<textarea name="olop[open_lazy_html_login_head]" id="olop[open_lazy_html_login_head]" rows="2" cols="80" placeholder="Login Head"><?php echo esc_textarea( olop('open_lazy_html_login_head') ) ?></textarea><br/>
		</fieldset>
		</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('UI','open-lazy')?></th>
		<td><fieldset>
			<label for="olop[open_lazy_ui_emoji]"><input name="olop[open_lazy_ui_emoji]" id="olop[open_lazy_ui_emoji]" type="checkbox" value="1" <?php checked(olop('open_lazy_ui_emoji'),1);?> /> <?php _e('Remove Emoji','open-lazy')?></label> <br/>
			<label for="olop[open_lazy_ui_open_sans]"><input name="olop[open_lazy_ui_open_sans]" id="olop[open_lazy_ui_open_sans]" type="checkbox" value="1" <?php checked(olop('open_lazy_ui_open_sans'),1);?> /> <?php _e('Disable Open-Sans','open-lazy')?></label> <br/>
			<?php if ( !wp_style_is('font-awesome','registered') && !wp_style_is('font-awesome-styles','registered') ): ?>
			<label for="olop[open_lazy_ui_font_awesome]"><input name="olop[open_lazy_ui_font_awesome]" id="olop[open_lazy_ui_font_awesome]" type="checkbox" value="1" <?php checked(olop('open_lazy_ui_font_awesome'),1);?> /> <?php _e('Enable Font-Awesome','open-lazy')?>
				<a href="http://fontawesome.io/" target="_blank">?</a></label> <br/>
			<?php endif; ?>
		</fieldset>
		</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('Unload','open-lazy')?></th>
		<td><fieldset>
			<label for="olop[open_lazy_unload_wp_head]">
			<textarea name="olop[open_lazy_unload_wp_head]" id="olop[open_lazy_unload_wp_head]" rows="4" cols="80" placeholder="[wp-head]"><?php echo esc_textarea( olop('open_lazy_unload_wp_head') ) ?></textarea></label><br/>
			<label for="olop[open_lazy_unload_dashboard]"><input name="olop[open_lazy_unload_dashboard]" id="olop[open_lazy_unload_dashboard]" size="81" placeholder="[wp_dashboard_setup]" value="<?php echo olop('open_lazy_unload_dashboard')?>" /></label><br/>
			<label for="olop[open_lazy_unload_admin_bar]"><input name="olop[open_lazy_unload_admin_bar]" id="olop[open_lazy_unload_admin_bar]" size="81" placeholder="[admin_bar_menu]" value="<?php echo olop('open_lazy_unload_admin_bar')?>" /></label>
			<p><a href="https://wordpress.org/support/topic/remove-feed-from-wp_head" target="_blank" class="button">#wp_head</a>
			<a href="https://codex.wordpress.org/Plugin_API/Action_Reference/wp_dashboard_setup" target="_blank" class="button">#wp_dashboard_setup</a>
			<a href="https://codex.wordpress.org/Function_Reference/remove_node" target="_blank" class="button">#admin_bar_menu</a></p>
		</fieldset>
		</td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('Extension','open-lazy')?></th>
		<td><fieldset>
			<label for="olop[open_lazy_ext_http_filter]"><input name="olop[open_lazy_ext_http_filter]" id="olop[open_lazy_ext_http_filter]" type="checkbox" value="1" <?php checked(olop('open_lazy_ext_http_filter'),1);?> /> <?php _e('Filter hosts HTTPS request to HTTP to prevent error','open-lazy')?></label> <br/>
			<label for="olop[open_lazy_ext_login_page]"><input name="olop[open_lazy_ext_login_page]" id="olop[open_lazy_ext_login_page]" type="checkbox" value="1" <?php checked(olop('open_lazy_ext_login_page'),1);?> /> <?php _e('Filter login page linker to local site','open-lazy')?></label><br/>
			<label for="olop[open_lazy_ext_remove_version]"><input name="olop[open_lazy_ext_remove_version]" id="olop[open_lazy_ext_remove_version]" type="checkbox" value="1" <?php checked(olop('open_lazy_ext_remove_version'),1);?> /> <?php _e('Remove version of resource file','open-lazy')?></label> <br/>
			<label for="olop[open_lazy_ext_view_site_new]"><input name="olop[open_lazy_ext_view_site_new]" id="olop[open_lazy_ext_view_site_new]" type="checkbox" value="1" <?php checked(olop('open_lazy_ext_view_site_new'),1);?> /> <?php _e('Make admin bar view-site link top and new','open-lazy')?></label> <br/>
		</fieldset><br/>
		<?php submit_button();?>
		</td>
		</tr>
		</table>
		<script>(function($){
		$('#screen-meta').after('<div id="screen-meta-links"><div id="screen-options-link-wrap" class="hide-if-no-js screen-meta-toggle"><a href="http://www.xiaomac.com/2015101692.html" id="show-settings-link" class="button show-settings" target="_blank"><?php _e("Supportive and Genuine","open-lazy")?></a></div></div>'
		);})(jQuery);</script>
	</div>

	<?php
}

function open_lazy_pack_style_zipper($css, $path) {
	$css = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', ' ', $css);
	$css = str_replace(array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), ' ', $css);
	$css = str_replace(array(';}', ' {', '} ', ': ', ' !', ', ', ' >', '> '),array('}',  '{',  '}',  ':',  '!',  ',',  '>',  '>'), $css);
	$dir = dirname($path).'/';
	$css = preg_replace('|url\(\'?"?([a-zA-Z0-9=#\?\&\-_\s\./]*)\'?"?\)|', "url(\"$dir$1\")", $css);
	return $css;
}

function open_lazy_pack_check_exclude($filter, $handle, $src){
	if(!$filter) return false;
	$arr = explode(',',$filter);
	return (in_array($handle, $arr)||in_array(basename($src), $arr));
}

if(olop('open_lazy_scs',1)){
	add_filter('upload_dir', 'open_lazy_scs_action');
	function open_lazy_scs_action( $param ){
		if(olop('open_lazy_scs_path')){
			$param['basedir'] = olop('open_lazy_scs_path');
			$param['path'] = $param['basedir'] . $param['subdir'];
		}
		if(olop('open_lazy_scs_url')){
			$param['baseurl'] = olop('open_lazy_scs_url');
			$param['url'] = $param['baseurl'] . $param['subdir'];
		}
		return $param;
	}
}

if(olop('open_lazy_html',1)){
	add_filter('the_content', 'open_lazy_html_action');
	function open_lazy_html_action($content) {
		if(is_single()) $content = olop('open_lazy_html_content_head') . $content . olop('open_lazy_html_content_footer');
		return $content;
	}
	if(olop('open_lazy_html_wp_head')) add_action('wp_head',function(){echo olop('open_lazy_html_wp_head');});
	if(olop('open_lazy_html_wp_footer')) add_action('wp_footer',function(){echo olop('open_lazy_html_wp_footer');});
	if(olop('open_lazy_html_login_head')) add_action('login_head',function(){echo olop('open_lazy_html_login_head');});
}

add_action( 'admin_bar_menu', 'open_lazy_unload_admin_bar_action', 999 );
function open_lazy_unload_admin_bar_action( $wp_admin_bar ) {
	if(olop('open_lazy_ext_view_site_new',1)) $wp_admin_bar->add_node(array('id'=>'view-site', 'parent'=>false, 'meta'=>array('target'=>'_blank')));
	if(olop('open_lazy_unload_admin_bar')){
		$remove = explode(',',olop('open_lazy_unload_admin_bar'));
		foreach($remove as $k){ $wp_admin_bar->remove_node(trim($k)); }
	}
}


if(olop('open_lazy_unload_dashboard')){
	add_action('wp_dashboard_setup', 'open_lazy_unload_dashboard_action',11 );
	function open_lazy_unload_dashboard_action() {
		$remove = explode(',',olop('open_lazy_unload_dashboard'));
		foreach($remove as $k){
			$tk = trim($k);
			if($tk=='dashboard_incoming_links'||$tk=='dashboard_plugins') remove_meta_box( $tk,'dashboard','normal' );
			else remove_meta_box( $tk,'dashboard','side' );
		}
	}
}

if(olop('open_lazy_ext_http_filter',1)){
	add_filter( 'pre_http_request', 'open_lazy_ext_http_filter_action', 10, 3 );
	function open_lazy_ext_http_filter_action( $false, $args, $url ){
		$purl = parse_url( $url );
		if ( 'https' === strtolower( $purl['scheme'] ) ){
			$new_url = substr_replace( $url, 'http', 0, 5 );
			30 > $args['timeout'] and $args['timeout'] = 30;
			$http = _wp_http_get_object();
			$result = $http->request( $new_url, $args );
			return $result;
		}
		return false;
	}
}

if(olop('open_lazy_ext_login_page',1)){
	add_filter('login_headertitle', function(){return get_option('blogname');});
	add_filter('login_headerurl', function(){return home_url( '/' );});
}

if(olop('open_lazy_ext_remove_version',1)){
	add_filter('script_loader_src', function($src){return remove_query_arg( 'ver', $src );});
	add_filter('style_loader_src', function($src){return remove_query_arg( 'ver', $src );});
}

?>